Package org.optaplanner.core.impl.score.stream.drools.tri

## Class DroolsFilterTriConstraintStream<Solution_,​A,​B,​C>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>
      - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsFilterTriConstraintStream<Solution_,​A,​B,​C>

- All Implemented Interfaces:
    `ConstraintStream`, `TriConstraintStream<A,​B,​C>`, `InnerTriConstraintStream<A,​B,​C>`

      public final class DroolsFilterTriConstraintStream<Solution_,​A,​B,​C>
      extends DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsFilterTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent, TriPredicate<A,​B,​C> triPredicate)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `TriLeftHandSide<A,​B,​C>` | `getLeftHandSide()` |
    `boolean` | `guaranteesDistinct()` | This method will return true if the constraint stream is guaranteed to only produce distinct tuples.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `filter, flattenLast, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join, map`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, getChildStreams, getConstraintFactory`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.tri.InnerTriConstraintStream

      `distinct, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.tri.TriConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsFilterTriConstraintStream

          public DroolsFilterTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                                 DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C> parent,
                                                 TriPredicate<A,​B,​C> triPredicate)

  - ### Method Detail

    - #### guaranteesDistinct

          public boolean guaranteesDistinct()

      Description copied from interface: `InnerTriConstraintStream`
      This method will return true if the constraint stream is guaranteed to only produce distinct tuples. See `InnerTriConstraintStream.distinct()` for details.
      Returns:
        true if the guarantee of distinct tuples is provided

    - #### getLeftHandSide

          public TriLeftHandSide<A,​B,​C> getLeftHandSide()

      Specified by:
        `getLeftHandSide` in class `DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`